Subject: Re: design for TSO performance fix

From: Nivedita Singhvi <[email-masked]>
Date: Thu, 27 Jan 2005 22:44:43 -0800

Andi Kleen wrote:

> I looked at this some time ago to pass lists of packets
> to qdisc and hard_queue_xmit, because that would allow less locking
> overhead and allow some drivers to send stuff more efficiently
> to the hardware registers
> (It was one of the items in my "how to speed up the stack" list ;-) 
> 
> I never ended up implementing it because TSO gave most of the advantages
> anyways.

I admit that it's been several months since I last looked
at this - and was just handwaving, had no code. But I had
thought the converse then - that it might be better
to abandon TSO and just have the stack pass down the list
of skbs in one pass. Had been mentioned by Andi as well as
Anton. We'd get much of the gain, avoid a lot of the
complexity, and the code would be simpler. And I'm not
positive about this but it seemed it would handle memory
fragmentation better, too.

Bogus?

thanks,
Nivedita